#ifndef NBC_EXT_H
#define NBC_EXT_H

extern char fname_base[MAX_FILENAME];
extern char fname_suffix[MAX_FILENAME];
extern char fname_freq[MAX_FILENAME_AUX];
extern char fname_param[MAX_FILENAME_AUX];
extern char fname_smooth[MAX_FILENAME_AUX];
extern char fname_dist[MAX_FILENAME_AUX];
extern char fname_memp[MAX_FILENAME_AUX];
extern char fname_log[MAX_FILENAME_AUX];
extern char fname_cluster[MAX_FILENAME_AUX];
extern char fname_rank[MAX_FILENAME_AUX];
extern char fname_rank_sm[MAX_FILENAME_AUX];
extern char fname_msg[MAX_FILENAME_AUX];
extern FILE *fp_log;
extern FILE *fp_msg;
extern FILE *fp_sm;
extern int mode_msg;
#ifdef USE_ICONV
#  ifdef CHARCODE
extern iconv_t cd_sys_in, cd_sys_out;
#  endif
extern iconv_t cd_in, cd_out;
#endif
extern char *buf_base;
extern char *buf_sys;
extern char *buf_delim;
extern char *buf_out;
extern FLOAT_TYPE stime_read;
extern FLOAT_TYPE stime_em;
extern FLOAT_TYPE stime_memp;
extern FLOAT_TYPE stime_kl_dist;
extern FLOAT_TYPE etime_read;
extern FLOAT_TYPE etime_em;
extern FLOAT_TYPE etime_memp;
extern FLOAT_TYPE etime_kl_dist;
extern FLOAT_TYPE stime_lap_read;
extern FLOAT_TYPE stime_lap_em;
extern FLOAT_TYPE stime_lap_memp;
extern FLOAT_TYPE stime_lap_kl_dist;
extern FLOAT_TYPE etime_lap_read;
extern FLOAT_TYPE etime_lap_em;
extern FLOAT_TYPE etime_lap_memp;
extern FLOAT_TYPE etime_lap_kl_dist;

extern int *freq_w_id;

extern char usage[];

extern int num_class_opt;
extern FREQ_PTR freq_list;
extern int total_freq;
extern int kmin;
extern int kmax;
extern int kstep;
extern int num_entry;
extern int num_entry_pre;
extern FLOAT_TYPE *param_c;
extern FLOAT_TYPE *read_param_c;
extern FLOAT_TYPE *param_c_opt;
extern FLOAT_TYPE *param_c_best;
extern FLOAT_TYPE *hparam_c;
extern FLOAT_TYPE ***hparam_w;
extern FLOAT_TYPE **prob_comp;
extern FLOAT_TYPE *prob_incomp;
extern FLOAT_TYPE **prob_cond;
extern FLOAT_TYPE *expect_c;
extern FLOAT_TYPE *tmp_expect_c;
extern FLOAT_TYPE *log_likelihood;
extern FLOAT_TYPE *log_prior;
extern FLOAT_TYPE *lambda;
extern FLOAT_TYPE *log_likelihood_best;
extern FLOAT_TYPE *log_prior_best;
extern FLOAT_TYPE *lambda_best;
extern FLOAT_TYPE final_log_likelihood;
extern FLOAT_TYPE final_log_prior;
extern FLOAT_TYPE final_lambda;
extern FLOAT_TYPE final_log_likelihood_best;
extern FLOAT_TYPE final_log_prior_best;
extern FLOAT_TYPE final_lambda_best;
extern FLOAT_TYPE *ic;
extern FLOAT_TYPE *bic;
extern FLOAT_TYPE *autoclass;

extern unsigned int **log_seed;
extern int **log_num_iterate;
extern int *log_r_best;
extern FLOAT_TYPE **log_final_lambda;

extern int num_sm;
extern int max_candidate;
extern int max_jsplit;
extern int mode_rank_sm;
extern int num_rank_sm;
extern int mode_norm;
extern FLOAT_TYPE min_param_c;
extern FLOAT_TYPE min_smem_improve;
extern FLOAT_TYPE min_new_param_c;
extern int **sm_candidate;
extern FLOAT_TYPE **jmerge;
extern FLOAT_TYPE *norm;
extern FLOAT_TYPE *jsplit;
extern FLOAT_TYPE *param_c_sm;
extern int num_candidate;
extern int *num_iterate_sm_full;
extern int *num_iterate_sm_part;
extern int *num_result_rejected;
extern int *num_result_skipped;
extern FLOAT_TYPE *param_c_part;
extern FLOAT_TYPE *prob_incomp_part;
extern FLOAT_TYPE **prob_cond_part;
extern FLOAT_TYPE **log_likelihood_sm;
extern FLOAT_TYPE **log_prior_sm;
extern FLOAT_TYPE **lambda_sm;

extern int mode_verbose;
extern int mode_em;
extern int mode_csv_in, mode_csv_out;
extern int mode_conv_in, mode_conv_out;
extern int mode_sys_out;
extern int mode_nomem;
extern FLOAT_TYPE smooth_c;
extern int mode_smooth;
extern int mode_smooth_strict;
extern int mode_auto_smooth;
extern enum smooth_auto_type mode_auto_smooth_c;
extern enum smooth_auto_type *mode_auto_smooth_w;
extern int mode_bdeu;
extern FLOAT_TYPE bdeu_min_smooth;
extern int mode_memp;
extern int mode_dist;
extern int mode_search_num_class;
extern int mode_suffix;
extern int mode_cluster;
extern int mode_set_seed;
extern int mode_lex_order;
extern int mode_rank;
extern int mode_as_is;
extern int mode_eval;
extern int mode_read_hparam;
extern int num_rank;
extern int num_class;
extern int num_ans_class;
extern int tuple_size;
extern int max_iterate;
extern int num_init;
extern int max_init_iterate;
extern FLOAT_TYPE epsilon;
extern enum info_criterion_type ic_type;
extern enum cluster_type cl_type;
extern enum initialization_type_for_class init_type_class;
extern enum initialization_type_for_word init_type_word;
extern enum relevance_measure rel_m;
extern char ic_type_str[ENUM_TYPE_LEN];
extern char cl_type_str[ENUM_TYPE_LEN];
extern char init_type_str_class[ENUM_TYPE_LEN];
extern char init_type_str_word[ENUM_TYPE_LEN];
extern char rel_m_str[ENUM_TYPE_LEN];
extern unsigned int rand_seed;
extern int *rank_class;
#ifdef USE_ICONV
extern char charcode_in[CHARCODE_LEN];
extern char charcode_out[CHARCODE_LEN];
#endif

extern HASHTABLE *ht;
extern HASHTABLE ht_vec;
extern HASHTABLE ht_class;

extern int *num_word;
extern char ***word_list;
extern int **word_freq_list;
extern char **ans_class_list;
extern int **print_order;
extern int **case_cluster;
extern int *case_cluster_pred;
extern int *case_cluster_freq;
extern int ***att_cluster;
extern int **att_cluster_pred;
extern int **att_cluster_freq;
extern FLOAT_TYPE ***param_w;
extern FLOAT_TYPE ***read_param_w;
extern FLOAT_TYPE ***param_w_opt;
extern FLOAT_TYPE ***param_w_best;
extern FLOAT_TYPE ***expect_w;
extern FLOAT_TYPE **prob_w;
extern FLOAT_TYPE **prob_case_mem;
extern FLOAT_TYPE ***prob_att_mem;
extern int **rank_case_mem;
extern int ***rank_att_mem;
extern FLOAT_TYPE **wodd_case;
extern FLOAT_TYPE ***wodd_att;
extern FLOAT_TYPE ***param_w_sm;
extern FLOAT_TYPE **prob_w_sm;
extern FLOAT_TYPE ***prob_att_mem_sm;
extern FLOAT_TYPE ***prob_att_mem_part;
extern int ***rank_att_mem_sm;
extern int ***rank_att_mem_part;
extern FLOAT_TYPE *smooth_w;

extern FLOAT_TYPE *tmp_param_c;
extern FLOAT_TYPE *tmp_rel_m;
extern FLOAT_TYPE **tmp_jmerge;
extern FLOAT_TYPE *tmp_jsplit;
extern char **tmp_word_list;

#endif /* NBC_EXT_H */
