#include "nbc_def.h"
#include "nbc_ext.h"

void copy_read_hparam(void)
{
  int k,v,i;

  for (k=0; k<num_class; k++) {
    hparam_c[k] = (read_param_c[k] + 1.0);
  }

  for (k=0; k<num_class; k++)
    for (v=0; v<tuple_size; v++)
      for (i=0; i<num_word[v]; i++)
	hparam_w[k][v][i] = (read_param_w[k][v][i] + 1.0);
}

/*
 * [Note] We also use read_param_body() and release_read_param() for
 * reading hyper-parameters.
 */
void read_hparam(void)
{
  int v,i;
  int max_num_class;
  FILE *fp_hparam;

  ht = (HASHTABLE *)malloc(sizeof(HASHTABLE)*tuple_size);
  if (ht == NULL)
    die("Couldn't allocate memory for ht\n");

  for (v=0; v<tuple_size; v++)
    init_hashtable(&ht[v]);

  num_word = (int *)malloc(sizeof(int)*tuple_size);
  if (num_word == NULL)
    die("Couldn't allocate memory for num_word\n");

  fp_hparam = fopen(fname_smooth,"rb"); /* binary mode */
  if (fp_hparam == NULL)
    die("Couldn't open %s\n", fname_smooth);

  max_num_class = read_param_body(fp_hparam);  /* allocate_read_param() is called */

  allocate_hparam();
  copy_read_hparam();
  release_read_param(max_num_class);

  word_list = (char ***)malloc(sizeof(char **)*tuple_size);
  if (word_list == NULL)
    die("Couldn't allocate memory for word_list\n");

  for (v=0; v<tuple_size; v++)
    word_list[v] = make_entry_list(&ht[v]); 

  print_order = (int **)malloc(sizeof(int *)*tuple_size);
  if (print_order == NULL)
    die("Couldn't allocate memory for print_order\n");

  for (v=0; v<tuple_size; v++) {
    print_order[v] = (int *)malloc(sizeof(int)*num_word[v]);
    for (i=0; i<num_word[v]; i++) {
      print_order[v][i] = i;
    }
    if (mode_lex_order) {
      tmp_word_list = word_list[v];
      qsort(print_order[v],num_word[v],sizeof(int),
            (int(*)(const void *,const void *))compare_word);
    }
  }

  if (mode_verbose) print_att_list(fp_log);
}
