#ifndef VNBC_DEF_H
#define VNBC_DEF_H

#define FSUFFIX_DIST_VB "dissim_vb"
#define FSUFFIX_MEMP_VB "memp_vb"
#define FSUFFIX_LOG_VB  "log_vb"
#define FSUFFIX_MSG_VB  "msg_vb"
#define FSUFFIX_CLUSTER_VB "cluster_vb"
#define FSUFFIX_RANK_VB "rank_vb"
#define FSUFFIX_SMEM_VB "smem_vb"
#ifdef NO_LDOUBLE
#  define ACCEPT_SMALL_NUMBER_PART (1.0e-3)
#else
#  define ACCEPT_SMALL_NUMBER_PART (1.0e-3L)
#endif

/* vbem.c */
void vbem_main(void);
void no_vbem_main(void);
void vbem_iterate(int);
int vbem_iterate_body(int,int,int);
int vbem_iterate_body_nomem(int,int,int);
FLOAT_TYPE compute_free_energy(void);
FLOAT_TYPE compute_free_energy_nomem(void);
void update_hparam(void);
void update_param_vbem(void);
void update_param_no_vbem(void);
int is_decreased(int,int,int);
int is_converged(int,int,int);
void initialize_hparam(void);
void compute_pi(void);
void save_free_energy_best(int);
void restore_free_energy_best(int);
void save_hparam_opt(void);
void restore_hparam_opt(void);
void save_hparam_best(void);
void restore_hparam_best(void);
/* vbsmem.c */
void vbsmem_iterate(int);
int vbsmem_iterate_full(int,int,int);
int vbsmem_iterate_part(int,int,int,int);
void compute_jsplit(void);
void compute_jmerge(void);
void initialize_hparam_part(int *);
void update_hparam_part(int *);
void compute_pi_part(int *);
void compute_complete_prob_part(int *);
void compute_incomplete_prob_part(int *);
void compute_conditional_prob_part(int *);
void compute_expect_prob_part(int *);
void compute_member_prob_sm(void);
void compute_member_prob_part(int *);
void sort_candidate(void);
int compare_candidate(const int **,const int **);
void save_hparam_sm(void);
void save_hparam_part(int *);
void save_free_energy_best_sm(int,int);
void restore_hparam_sm(void);
void restore_free_energy_best_sm(int,int);
void release_hparam_sm(void);
/* read_param_vb.c */
void read_hparam(void);
void copy_read_hparam(void);
/* allocate_vb.c */
void allocate_seed_vb(void);
void allocate_hparam_upd(void);
void allocate_hparam_best(void);
void allocate_hparam_opt(void);
void allocate_hparam_sm(void);
void allocate_hparam_part(void);
void allocate_free_energy(void);
void allocate_free_energy_best(void);
void allocate_free_energy_sm(void);
void allocate_pi(void);
void release_seed_vb(void);
void release_hparam_upd(void);
void release_hparam_best(void);
void release_hparam_opt(void);
void release_hparam_sm(void);
void release_hparam_part(void);
void release_free_energy(void);
void release_free_energy_best(void);
void release_free_energy_sm(void);
void release_pi(void);
/* cluster_vb.c */
void cluster_main_vb(void);
/* rank_vb.c */
void rank_main_vb(void);
/* print_vb.c */
void print_time_vb(FILE *);
void print_hparam(FILE *);
void print_hparam_upd(FILE *);
void print_pi(FILE *);
void print_free_energy(FILE *,int,int);
void print_free_energy_sm(FILE *,int);
void print_ic(FILE *);
void print_rank_sm(FILE *,int,int *);

#endif
